﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace XamGridAddingColumnPersistedConfig
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
            IsVisibleChanged += MainWindow_IsVisibleChanged;
            NameTextBox.GotKeyboardFocus += Name_GotKeyboardFocus;
        }

        private async void MainWindow_IsVisibleChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            IsVisibleChanged -= MainWindow_IsVisibleChanged;
            XamGrid.ItemsSource = new TestDataList(200);
            await Task.Delay(2000);
            ConfigManager.Initialize(XamGrid);
            ComboBox.ItemsSource = ConfigManager.Configs;
            ComboBox.SelectedItem = ConfigManager.Configs[0];

            XamGrid.Columns.Insert(2, new DateColumn()
            {
                Key = "Wedding",
                HeaderText = "Wedding",
                Width = new ColumnWidth(150, false)
            });
        }

        private void LoadConfig(object sender, RoutedEventArgs e)
        {
            ConfigManager.LoadConfig((Configs)ComboBox.SelectedItem, XamGrid);
        }

        private async void SaveConfig(object sender, RoutedEventArgs e)
        {
            if (string.IsNullOrEmpty(NameTextBox.Text)) {
                NameTextBox.Background = Brushes.Red;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.White;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.Red;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.White;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.Red;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.White;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.Red;
                await Task.Delay(150);
                NameTextBox.Background = Brushes.White;
                return;
            }

            var config = new Configs {Name = NameTextBox.Text};
            ConfigManager.Configs.Add(config);
            ComboBox.ItemsSource = null;
            ComboBox.ItemsSource = ConfigManager.Configs;
            ComboBox.SelectedItem = config;
            ConfigManager.SaveConfig((Configs)ComboBox.SelectedItem, XamGrid);
            
        }

        private void Name_GotKeyboardFocus(object sender, KeyboardFocusChangedEventArgs e)
        {
            NameTextBox.Background = Brushes.White;
        }

        private void DeleteConfig(object sender, RoutedEventArgs e)
        {
            var config = ConfigManager.RemoveConfig((Configs) ComboBox.SelectedItem, XamGrid);
            ComboBox.ItemsSource = null;
            ComboBox.ItemsSource = ConfigManager.Configs;
            ComboBox.SelectedItem = config;
        }
    }



}
